#include <stdio.h>
#include <string.h>

void print(const unsigned char* canary, const unsigned char* foo) {
    printf("foo (0x%08x) = %02x%02x%02x%02x ;  canary (0x%08x) = %02x%02x%02x%02x%02x \n",
        foo, foo[0], foo[1], foo[2], foo[3],
        canary, canary[0], canary[1], canary[2], canary[3], canary[4]
    );
}

void f() {
    unsigned char canary[] = "AAAA";
    unsigned char foo[4];
    foo[0] = foo[1] = foo[2] = foo[3] = '\0';
    
    print(canary, foo);
    printf("%128u%n%192u%n%224u%n%240u%n\n",
        0, (int*) &foo[0],
        0, (int*) &foo[1],
        0, (int*) &foo[2],
        0, (int*) &foo[3]);
    print(canary, foo);
}

int main(int argc, char* argv[]) {
    f();
    return 0;
}
