#include <stdio.h>
#include <string.h>

void print(const unsigned char* canary, const unsigned char* foo) {
    printf("foo (0x%08x) = %02x%02x%02x%02x ;  canary (0x%08x) = %02x%02x%02x%02x%02x \n",
        foo, foo[0], foo[1], foo[2], foo[3],
        canary, canary[0], canary[1], canary[2], canary[3], canary[4]
    );
}

unsigned padding(unsigned write_byte) {
    static unsigned already_written = 0;
    
    write_byte += 0x100;
    already_written %= 0x100;
    unsigned padding = (write_byte - already_written) % 0x100;
    if(padding < 10) padding += 0x100;
    
    already_written += padding;
    return padding;
}

void f() {
    unsigned char canary[] = "AAAA";
    unsigned char foo[4];
    foo[0] = foo[1] = foo[2] = foo[3] = '\0';
    
    unsigned pad[4];
    pad[0] = padding(0x80);
    pad[1] = padding(0x40);
    pad[2] = padding(0x20);
    pad[3] = padding(0x10);
    
    print(canary, foo);
    printf("%*u%n%*u%n%*u%n%*u%n\n", 
        pad[0], 0, (int*) &foo[0],
        pad[1], 0, (int*) &foo[1],
        pad[2], 0, (int*) &foo[2],
        pad[3], 0, (int*) &foo[3]
    );
    print(canary, foo);
}

int main(int argc, char* argv[]) {
    f();
    return 0;
}

